/* a link list program */
#include <stdio.h>
#ifndef NULL
#define MULL 0
#endif

/* link list structure */
struct list
{
	int ch;
	struct list *next_rec;
};

typedef struct list LIST;
typedef LIST *LISTPTR;

/*-----------------------*/

LISTPTR add_to_list(int,LISTPTR);
void show_list(LISTPTR);
void free_memory_list(LISTPTR);

/* show list */

void show_list(LISTPTR first)
{
	LISTPTR cur_ptr;
	int counter = 1;
	printf("\n\nRec addr  Position  Data  Next Rec addr \n");
	printf("==============================================\n");
	cur_ptr = first;
	while (cur_ptr !=NULL)
	{
		printf("  %X   ",cur_ptr);
		printf("     %2i       %c",counter++,cur_ptr->ch);
		printf("     %X    \n",cur_ptr->next_rec);
		cur_ptr = cur_ptr->next_rec;
	}
}

/* free memory list */

void free_memory_list(LISTPTR first)
{
	LISTPTR cur_ptr,next_rec;
	cur_ptr = first;
	while (cur_ptr != NULL)
	{
		next_rec = cur_ptr->next_rec;
		free(cur_ptr);
		cur_ptr = next_rec;
	}
}
